<div *ngIf="!isEdit && product" class="card product-detail--view">
  <!--suppress HtmlUnknownTarget -->
  <img src="/assets/product.jpg" alt="product image" class="card-img-top" />
  <div class="card-body">
    <div class="card-title d-flex justify-content-between">
      <h5 class="name">{{product.name | uppercaseFirstLetter}}</h5>
      <span class="ml-3">
        <span class="cost badge badge-success"  ngbTooltip="cost of product">{{product.cost | currency}}</span>
        <span class="count badge badge-warning ml-1" ngbTooltip="count of product in stock ">{{product.count}}</span>
      </span>
    </div>
    <div class="mt-2 mb-2">
    <span *ngFor="let category of product.categories; last as isLast">
      <a class="category btn btn-primary btn-sm" [class.mr-1]="!isLast" [routerLink]="['/categories', category.id]">
        {{category.name}}
      </a>
    </span>
    </div>
    <p class="description card-text">{{product.description}}</p>
  </div>
  <div class="card-footer d-flex justify-content-end" *ngIf="isAdmin">
    <button class="btn-add btn btn-primary" (click)="addNewProduct()">Add new</button>
    <a class="a-edit btn btn-primary ml-1" [routerLink]="['edit']">Edit</a>
    <button class="btn-delete btn btn-danger ml-1" (click)="delete()">Delete</button>
  </div>
</div>

<form *ngIf="isEdit" [formGroup]="productForm" class="product-detail--edit">
  <fieldset [disabled]="isPending">
    <legend>Product</legend>
    <div class="error-server" *ngIf="serverErrorMsg">{{serverErrorMsg}}</div>
    <div class="form-group">
      <label for="name">Name:</label>
      <input id="name" class="form-control" [class.is-invalid]="name.invalid && name.dirty"
             type="text" formControlName="name" name="name" required/>
      <div class="invalid-feedback" [class.show]="name.errors">{{getNameErrorMsg()}}</div>
    </div>
    <div class="form-group">
      <label for="description">Description:</label>
      <textarea id="description" class="form-control" formControlName="description" cols="80" rows="12" name="description"></textarea>
    </div>
    <div class="form-group">
      <label for="cost">Cost:</label>
      <input id="cost" class="form-control" [class.is-invalid]="cost.invalid && cost.dirty"
             type="text" formControlName="cost" name="cost" required />
      <div class="invalid-feedback" [class.show]="cost.errors">{{getCostErrorMsg()}}</div>
    </div>
    <div class="form-group">
      <label for="count">Count:</label>
      <input id="count" class="form-control" [class.is-invalid]="count.invalid && count.dirty"
             type="text" formControlName="count" name="count" required />
      <div class="invalid-feedback" [class.show]="count.errors">{{getCountErrorMsg()}}</div>
    </div>
    <div class="d-flex justify-content-end">
      <button class="btn-update btn btn-primary" *ngIf="!isAddNew" [disabled]="productForm.invalid" (click)="update()" >Update</button>
      <button class="btn-save btn btn-primary ml-1" *ngIf="isAddNew" [disabled]="productForm.invalid" (click)="save()" >Save</button>
      <button class="btn-cancel btn btn-secondary ml-1" (click)="cancel()">Cancel</button>
    </div>
    <!--<pre>{{productForm.errors | json}}</pre>

    <pre>{{productForm.status}}</pre>
    <pre>{{productForm.valid}}</pre>
    <pre>{{productForm.get('name').errors | json}}</pre>
    <pre>{{productForm.get('cost').errors | json}}</pre>
    <pre>{{productForm.get('count').errors | json}}</pre>-->
  </fieldset>
</form>
